"use strict";

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const curry = require('lodash/curry');

const effect = (effectFn, action) => async (context, ...otherArgs) => {
  const {
    derivedState,
    derivedParam
  } = (await effectFn(context, ...otherArgs)) || {};

  if (derivedState) {
    context.setState(derivedState);
  }

  if (derivedParam) {
    const [param, ...argsFromIndex2] = otherArgs;

    if (!param || typeof param === 'object') {
      return action(context, _objectSpread({}, param, derivedParam), ...argsFromIndex2);
    }
  }

  return action(context, ...otherArgs);
};

module.exports = curry(effect);